"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MockRegistry = exports.HookRegistry = exports.FetchpStatus = exports.fetchp = exports.default = exports.Fetchp = exports.FetchpHookType = exports.CacheRegistry = void 0;
const fetchp_js_1 = require("./fetchp.js");
Object.defineProperty(exports, "CacheRegistry", { enumerable: true, get: function () { return fetchp_js_1.CacheRegistry; } });
Object.defineProperty(exports, "FetchpHookType", { enumerable: true, get: function () { return fetchp_js_1.FetchpHookType; } });
Object.defineProperty(exports, "FetchpStatus", { enumerable: true, get: function () { return fetchp_js_1.FetchpStatus; } });
Object.defineProperty(exports, "HookRegistry", { enumerable: true, get: function () { return fetchp_js_1.HookRegistry; } });
Object.defineProperty(exports, "MockRegistry", { enumerable: true, get: function () { return fetchp_js_1.MockRegistry; } });
// implementation (public)
// -----------------------
class FetchpMock extends fetchp_js_1.Fetchp {
    constructor() {
        super();
        Object.defineProperty(this, "mockResponseFn", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.mockResponseFn = () => Promise.resolve(new Response());
    }
    setMockResponseFn(responseFn) {
        this.mockResponseFn = responseFn;
    }
    internalFetcher(request) {
        return this.mockResponseFn(request);
    }
}
exports.Fetchp = FetchpMock;
// singleton instance for predefined, default fetchp object
const fetchpMock = new FetchpMock();
exports.default = fetchpMock;
exports.fetchp = fetchpMock;
