"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UrlCollection = void 0;
// interface definitions
// ---------------------
const dntShim = __importStar(require("./_dnt.shims.js"));
var UrlCollectionItemType;
(function (UrlCollectionItemType) {
    UrlCollectionItemType["String"] = "STRING";
    UrlCollectionItemType["RegExp"] = "REGEXP";
    UrlCollectionItemType["URLPattern"] = "URLPATTERN";
})(UrlCollectionItemType || (UrlCollectionItemType = {}));
class UrlCollection {
    constructor() {
        Object.defineProperty(this, "items", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this.items = [];
    }
    add(methods, requestUrlPattern, data) {
        const methods_ = methods.constructor === Array
            ? methods
            : [methods];
        const requestUrlPatternType = requestUrlPattern.constructor === RegExp
            ? UrlCollectionItemType.RegExp
            : requestUrlPattern.constructor === dntShim.URLPattern
                ? UrlCollectionItemType.URLPattern
                : UrlCollectionItemType.String;
        this.items.push({
            methods: methods_,
            requestUrlPattern,
            requestUrlPatternType,
            data,
        });
    }
    clear() {
        this.items = [];
    }
    filter(method, uri, urlConverter) {
        const foundItems = this.items
            .filter((x) => x.methods.includes(method))
            .filter((x) => {
            const uri_ = typeof uri === "function" ? uri() : uri;
            if (x.requestUrlPatternType === UrlCollectionItemType.RegExp) {
                return x.requestUrlPattern.test(uri_);
            }
            else if (x.requestUrlPatternType === UrlCollectionItemType.URLPattern) {
                return x.requestUrlPattern.test(uri_);
            }
            if (urlConverter !== undefined) {
                const convertedUrl = urlConverter(x.requestUrlPattern).toString();
                return convertedUrl === uri;
            }
            return x.requestUrlPattern === uri;
        });
        return foundItems;
    }
    filterByRequest(request, urlConverter) {
        return this.filter(request.method, request.url, urlConverter);
    }
}
exports.UrlCollection = UrlCollection;
