import * as dntShim from "./_dnt.shims.js";
import { type FetchpURI, UrlCollection, type UrlCollectionInterface } from "./uris.js";
type MockResponseFn = (request: Request) => Promise<Response>;
interface MockRegistryInterface {
    items: UrlCollectionInterface<MockResponseFn>;
    add(methods: string | string[], requestUrlPattern: string | RegExp | dntShim.URLPattern, response: Response | MockResponseFn): void;
    clear(): void;
    find(request: Request, urlConverter?: (uri: FetchpURI) => URL): {
        request: Request;
        responseFn: MockResponseFn | undefined;
    };
}
declare class MockRegistry implements MockRegistryInterface {
    items: UrlCollection<MockResponseFn>;
    constructor();
    add(methods: string | string[], requestUrlPattern: string | RegExp | dntShim.URLPattern, response: Response | MockResponseFn): void;
    clear(): void;
    find(request: Request, urlConverter?: (uri: FetchpURI) => URL): {
        request: Request;
        responseFn: undefined;
    } | {
        request: Request;
        responseFn: MockResponseFn;
    };
}
export { MockRegistry, type MockRegistryInterface };
