import * as dntShim from "./_dnt.shims.js";
type FetchpURI = string | ((params?: Record<string, string | undefined>) => string);
declare enum UrlCollectionItemType {
    String = "STRING",
    RegExp = "REGEXP",
    URLPattern = "URLPATTERN"
}
interface UrlCollectionItem<T = unknown> {
    methods: string[];
    requestUrlPattern: string | RegExp | dntShim.URLPattern;
    requestUrlPatternType: UrlCollectionItemType;
    data: T;
}
interface UrlCollectionInterface<T = unknown> {
    items: UrlCollectionItem<T>[];
    add(methods: string | string[], requestUrlPattern: string | RegExp | dntShim.URLPattern, data: T): void;
    clear(): void;
    filter(method: string, uri: FetchpURI, urlConverter?: (uri: FetchpURI) => URL): UrlCollectionItem<T>[];
    filterByRequest(request: Request, urlConverter?: (uri: FetchpURI) => URL): UrlCollectionItem<T>[];
}
declare class UrlCollection<T = unknown> implements UrlCollectionInterface<T> {
    items: UrlCollectionItem<T>[];
    constructor();
    add(methods: string | string[], requestUrlPattern: string | RegExp | dntShim.URLPattern, data: T): void;
    clear(): void;
    filter(method: string, uri: FetchpURI, urlConverter?: (uri: FetchpURI) => URL): UrlCollectionItem<T>[];
    filterByRequest(request: Request, urlConverter?: (uri: FetchpURI) => URL): UrlCollectionItem<T>[];
}
export { type FetchpURI, UrlCollection, type UrlCollectionInterface, type UrlCollectionItem, };
